//
// @file:			main.cc
// author:			E^rthW( )rm 2003
// last mod:			Friday, September 05 2003
// about:			program entry point for wp_tray 
// license:			GPL

// includes //
//
#include <config.h>
#include <iostream>
#include <libintl.h>
#include <libgnomemm/main.h>
#include <libgnomeuimm/init.h>
#include <panel-applet.h>
#include "applet.hh"
#include "config.h"
#include <glib/gi18n.h>

// wp_tray_factory //
//
gboolean
wp_tray_factory				(PanelApplet				* p_panel_applet,
					 const gchar				* str_iid,
					 void *					p_data)
{
	// construct applet
	c_applet * p_applet = manage(new c_applet(p_panel_applet));
	p_applet->show();
  
	gtk_container_add(GTK_CONTAINER(p_panel_applet), GTK_WIDGET(p_applet->gobj()));
	gtk_widget_show(GTK_WIDGET(p_panel_applet));
  
	return true;
}// end wp_tray_factory

// program entry point //
//
int
main					(int					argc,
					 char					*argv[])
{
	Gnome::Main main(PACKAGE, VERSION, Gnome::UI::module_info_get(), argc, argv);
  
	try
	{
		// i18n
		bindtextdomain(GETTEXT_PACKAGE, GNOMELOCALEDIR);
		bind_textdomain_codeset(GETTEXT_PACKAGE, "UTF-8");

		textdomain(GETTEXT_PACKAGE);

		panel_applet_factory_main	(
							"OAFIID:wp_tray_Factory",
							PANEL_TYPE_APPLET,
							&wp_tray_factory,
							0
						);
	}
	catch(const Glib::Error &ex)
	{
		std::cerr << ex.what() << std::endl;
	}
	return 0;
}
