//
// file:	preferences_dialog.hh
// author:	earthworm
// date:	Sunday, 01 May 2005
// about:	declares preferences dialog for wp_tray
//

// includes //
//
#include <gtkmm.h>
#include <libglademm.h>
#include <gconfmm-2.6/gconfmm.h>
#include <list>

#ifndef _PREFERENCES_DIALOG_H_
#define _PREFERENCES_DIALOG_H_

// declarations //
//
class c_preferences_dialog_model_columns : public Gtk::TreeModel::ColumnRecord
{
	public:
		Gtk::TreeModelColumn<Glib::ustring>                directory_name;
		
		c_preferences_dialog_model_columns()
		{
			add(directory_name);
		}// end c_preferences_dialog_model_columns
};// end class c_preferences_dialog_model_columns

class c_preferences_dialog : public Gtk::Dialog
{
	// internal class data //
	//
	private:
		const Glib::RefPtr<Gnome::Glade::Xml>	& m_ref_glade;
		Glib::RefPtr<Gnome::Conf::Client>	m_ref_gconf_client;

		Gtk::Button				* m_p_button_close;
		Gtk::Button				* m_p_button_apply;
		Gtk::Button				* m_p_button_add_dir;
		Gtk::Button				* m_p_button_rem_dir;

		Gtk::Entry				* m_p_entry_time;
		Gtk::Entry				* m_p_entry_mode;
		Gtk::Entry				* m_p_entry_selection_mode;

		Gtk::CheckButton			* m_p_checkbutton_timeout;
		Gtk::CheckButton			* m_p_checkbutton_logon_new;
		Gtk::CheckButton			* m_p_checkbutton_image_check;
		Gtk::CheckButton			* m_p_checkbutton_follow_links;
		Gtk::TreeView				* m_p_treeview_directories;

		c_preferences_dialog_model_columns	m_preferences_dialog_model_columns;
		Glib::RefPtr<Gtk::ListStore>		m_ref_liststore_directories;

		std::list<Glib::ustring>		m_ls_wp_dir;
		int					m_n_timeout;
		bool					m_b_timeout;
		bool					m_b_wp_logon;
		bool					m_b_img_check;
		bool					m_b_follow_links;
		Glib::ustring				m_sz_picture_options;

	// internal class interface //
	//
	private:
		void
		get_settings_in_gconf			();

		void
		set_settings_in_gconf			();

	// public class interface //
	//
	public:
		c_preferences_dialog		(BaseObjectType				* p_window,
						 const Glib::RefPtr<Gnome::Glade::Xml>	& ref_glade);

		virtual
		~c_preferences_dialog		();

		void
		on_button_close_click		();

		void
		on_button_apply_click		();

		void
		on_button_add_dir_click		();

		void
		on_button_rem_dir_click		();

		void
		on_entry_time_changed		();

};// end class c_preferences_dialog

#endif	// _PREFERENCES_DIALOG_H_
