//
// file:	search_dialog.hh
// author:	earthworm
// date:	Wednesday, 27 April 2005
// about:	declares c_search class
//

// includes //
//
#include <gtkmm.h>
#include <libglademm.h>
#include <libgnomeuimm/druid.h>
#include <libgnomeuimm/druid-page-standard.h>
#include <gconfmm-2.6/gconfmm.h>
#include "boost/filesystem/operations.hpp"
#include "boost/filesystem/fstream.hpp"
#include "boost/regex.hpp"

#ifndef _SEARCH_DIALOG_H_
#define _SEARCH_DIALOG_H_

namespace fs = boost::filesystem;

// declarations //
//

class c_search_dialog_model_columns : public Gtk::TreeModel::ColumnRecord
{
	public:
		Gtk::TreeModelColumn<Glib::ustring>	directory_name;
		
		c_search_dialog_model_columns()
		{
			add(directory_name);
		}// end c_search_dialog_model_columns

};// end class c_search_dialog_model_columns

class c_search_dialog : public Gtk::Dialog
{
	// protected class data //
	//
	protected:
		const Glib::RefPtr<Gnome::Glade::Xml>	& m_ref_glade;
		Glib::RefPtr<Gnome::Conf::Client>	m_ref_gconf_client;

		Gnome::UI::Druid			* m_p_druid;
		Gnome::UI::DruidPage			* m_p_druid_page_std_start;
		Gnome::UI::DruidPage			* m_p_druid_page_std_search_string;
		Gnome::UI::DruidPage			* m_p_druid_page_finish;
		
		Gtk::Entry				* m_p_entry_search_string;

		Gtk::TreeView				* m_p_treeview;
		c_search_dialog_model_columns		m_model;
		Glib::RefPtr<Gtk::ListStore>		m_ref_liststore;

		Gtk::RadioButton			* m_p_radio_button_select;
		Gtk::RadioButton			* m_p_radio_button_delete;

	// public class interface //
	//
	public:
		c_search_dialog			(BaseObjectType				* p_dialog,
						 const Glib::RefPtr<Gnome::Glade::Xml>	& ref_glade);

		virtual
		~c_search_dialog		();

	// protected class interface //
	//
	protected:
		virtual bool
		on_button_next_click		(Gtk::Widget				& ref_druid);

		void
		on_button_apply_click		(Gtk::Widget				& ref_widget);

		void
		on_button_cancel_click		();

		void
		on_show				();

		void
		wallpaper_search		(fs::path				path_current,
						 const boost::regex			& ref_regex,
						 std::list<Glib::ustring>		& ref_ls_results);

};// end class c_search_dialog

#endif	// _SEARCH_DIALOG_H_
